
///    (Brenkman Andrey)
///   20.11.2010
///    99%




///!
#include "a_Header_constants.h"
#include "a_List.h"
#include "a_Position.h"

/// -(1-0)    
#define KONTROL_B 0 

/// 
#define TEST_H 0 



///  (bit board) 
///           
///   :
/// "Hyatt, Robert. Rotated bitmaps, a new twist on an old idea"

///      Chess_bitboard   
///            
/// +   

///              
///            

/// 
///        
///   (7.09.11) (bugs)  


///---------------------------------------------------------------------------
///    
class h_Generator_moves 
{

//////////////////////////////////////////////////////////////////////////////////////
public:

	///---------------------------------------------------------------------------
	///    +   ( )
	void generator_captures_white
	(
		struct List & list,///   
		const struct Position & position ///              
	);

	///---------------------------------------------------------------------------
	///     +   ( )
	void generator_captures_black
	(
		struct List & list,///   
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///     
	/// (..     +  )( )
	void generator_move_white
	(
		struct List & list,///   
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///     
	/// (..     +  )( )
	void generator_move_black
	(
		struct List & list,///   
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///           
	///  0    
	unsigned __int8 king_white_check
	(
		const struct Position & position ///     
	);

	///---------------------------------------------------------------------------
	///           
	///  0    
	unsigned __int8 king_black_check
	(
		const struct Position & position ///     
	);


//////////////////////////////////////////////////////////////////////////////////////
private:


	///---------------------------------------------------------------------------
	///           
	///  0    
	inline unsigned __int8 white_check_square
	(
		const unsigned __int8 & sq,///  (0-63) 
		const struct Position & position ///     
	);

	///---------------------------------------------------------------------------
	///           
	///  0    
	inline unsigned __int8 black_check_square
	(
		const unsigned __int8 & sq,///  (0-63) 
		const struct Position & position ///     
	);

	///---------------------------------------------------------------------------
	///    -   
	///        ( )
	inline void list_capture_white
	(
		struct List & list,///   
		const unsigned __int8 name,///   
		const unsigned __int8 type_move,///  
		const unsigned __int8 & from,///  
		const unsigned __int8 & to,///  
		unsigned __int8 & count,///    
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///    -   
	///        ( )
	inline void list_capture_black
	(
		struct List & list,///   
		const unsigned __int8 name,///   
		const unsigned __int8 type_move,///  
		const unsigned __int8 & from,///  
		const unsigned __int8 & to,///  
		unsigned __int8 & count,///    
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///   
	inline void list_record_move_white
	(
		struct List & list,///   
		const unsigned __int8 name,///   
		const unsigned __int8 type_move,///  
		const unsigned __int8 & from,///  
		const unsigned __int8 & to,///  
		unsigned __int8 & count,///    
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///   
	inline void list_record_move_black
	(
		struct List & list,///   
		const unsigned __int8 name,///   
		const unsigned __int8 type_move,///  
		const unsigned __int8 & from,///  
		const unsigned __int8 & to,///  
		unsigned __int8 & count,///    
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///         
	///      
	inline void list_record_special
	(
		struct List & list,///   
		const unsigned __int8 name,///   
		const unsigned __int8 d_m,///  
		unsigned __int8 & count,///    
		const unsigned __int8 & from,///  
		const unsigned __int8 to,///  
		const unsigned __int8 capture///   
	);

	///---------------------------------------------------------------------------
	///     ,         
	///       
	inline void KONTROL_captures_W
	(
		const struct Position & position, ///      
		const unsigned __int8 & from,///   
		const unsigned __int8 & to,///   
		const unsigned __int8 & p,///    
		const unsigned __int8 name_figure///   
	);

	///---------------------------------------------------------------------------
	///     ,         
	///       
	inline void KONTROL_captures_B
	(
		const struct Position & position, ///      
		const unsigned __int8 & from,///   
		const unsigned __int8 & to,///   
		const unsigned __int8 & p,///    
		const unsigned __int8 name_figure///   
	);

	///---------------------------------------------------------------------------
	///     ,    
	///    
	inline void KONTROL_move
	(
		const unsigned __int8 & from,//   
		const unsigned __int8 & to,//   
		const unsigned __int8 & p//    
	);


//////////////////////////////////////////////////////////////////////////////////////
public:

	///---------------------------------------------------------------------------
	///    (..  )
	__inline __int32 bit_scan_forward_win32
	(
		const unsigned __int64 analyzed_number///      
	);

	///---------------------------------------------------------------------------
	///    (..  )
	__inline __int32 bit_scan_reverse_win32
	(
		const unsigned __int64 analyzed_number///      
	);
};