
///    (Brenkman Andrey)
///   27.02.2009
///    70%


///!
#include "a_Header_constants.h"
#include "a_List.h"


///   

struct PV_line
{
	///      List
	__int32 move[MAX_DEPTH]; 

	///  
	__int32 score_move;

	///  
	unsigned __int8  depth_max;

};

class m_PV_save
{

///  
//////////////////////////////////////////////////////////////////////////////////////
private:

	struct PV_line pv_current;///      (    )
	struct PV_line pv_best;///      (  )

	__int32 save_value; ///     
	unsigned __int8 save_Depth_Max; ///     


//////////////////////////////////////////////////////////////////////////////////////
public:

	///---------------------------------------------------------------------------
	///   
	struct PV_line & get_pv_best();

	///---------------------------------------------------------------------------
	///   
	struct PV_line & get_pv_current();

	///---------------------------------------------------------------------------
	///      
	void update_PV_best_point
	(
		struct PV_line & PV_best_point///     
	);

	///---------------------------------------------------------------------------
	///    
	void update_PV_best
	(
		const struct PV_line & PV_best_point///     
	);

	///---------------------------------------------------------------------------
	///       
	void update_PV_best_max_depth
	(
		const __int32 & score,///     
		const unsigned __int8 & depth///  
	);

	///---------------------------------------------------------------------------
	///     
	void update_PV_current
	(
		const unsigned __int8 & i,///     
		const unsigned __int8 & depth,///  
		const struct List & list_surplus_moves///  
	);

	///---------------------------------------------------------------------------
	///    
	void print_currmove
	(
		const struct List & list_surplus_moves,///  
		const unsigned __int8 nodes_0,///     
		const unsigned __int8 i,///    
		const unsigned __int8 Depth_Max///  
	);

	///---------------------------------------------------------------------------
	///     
	void print_pv_line
	(
		const bool colour_move,///   
		const struct List & list_surplus_moves,///  
		const struct PV_line & PV_best_point,///  
		const __int64 print_nodes,///  
		const unsigned __int8 i,///    
		const unsigned __int8 Depth_Max,///  
		const __int32 value,///  
		const bool all_line///   
		//,const double time_nodes//   
	);


//////////////////////////////////////////////////////////////////////////////////////
public:

	///-----------------------------------------------------------------
	///        9.01.06 
	///     :)) 
	///     
	/// 0- , 1-, 2-, 3-, 4-, 5-, 6-	
	__int8 int_to_char_board
	(
		const int i,///  
		const int z///  
	);

	///---------------------------------------------------------------------------
	///	        0 - '', 1 - 'b', ..., 7 - 'h'	
	__int8 x_to_notation
	(
		const int x///    (0-7)
	);

};
